package com.jay.monitor.data.server.models.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BackstageUrlExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public BackstageUrlExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andUrlIsNull() {
            addCriterion("url is null");
            return (Criteria) this;
        }

        public Criteria andUrlIsNotNull() {
            addCriterion("url is not null");
            return (Criteria) this;
        }

        public Criteria andUrlEqualTo(String value) {
            addCriterion("url =", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlNotEqualTo(String value) {
            addCriterion("url <>", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlGreaterThan(String value) {
            addCriterion("url >", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlGreaterThanOrEqualTo(String value) {
            addCriterion("url >=", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlLessThan(String value) {
            addCriterion("url <", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlLessThanOrEqualTo(String value) {
            addCriterion("url <=", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlLike(String value) {
            addCriterion("url like", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlNotLike(String value) {
            addCriterion("url not like", value, "url");
            return (Criteria) this;
        }

        public Criteria andUrlIn(List<String> values) {
            addCriterion("url in", values, "url");
            return (Criteria) this;
        }

        public Criteria andUrlNotIn(List<String> values) {
            addCriterion("url not in", values, "url");
            return (Criteria) this;
        }

        public Criteria andUrlBetween(String value1, String value2) {
            addCriterion("url between", value1, value2, "url");
            return (Criteria) this;
        }

        public Criteria andUrlNotBetween(String value1, String value2) {
            addCriterion("url not between", value1, value2, "url");
            return (Criteria) this;
        }

        public Criteria andServiceNameIsNull() {
            addCriterion("service_name is null");
            return (Criteria) this;
        }

        public Criteria andServiceNameIsNotNull() {
            addCriterion("service_name is not null");
            return (Criteria) this;
        }

        public Criteria andServiceNameEqualTo(String value) {
            addCriterion("service_name =", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameNotEqualTo(String value) {
            addCriterion("service_name <>", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameGreaterThan(String value) {
            addCriterion("service_name >", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameGreaterThanOrEqualTo(String value) {
            addCriterion("service_name >=", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameLessThan(String value) {
            addCriterion("service_name <", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameLessThanOrEqualTo(String value) {
            addCriterion("service_name <=", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameLike(String value) {
            addCriterion("service_name like", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameNotLike(String value) {
            addCriterion("service_name not like", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameIn(List<String> values) {
            addCriterion("service_name in", values, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameNotIn(List<String> values) {
            addCriterion("service_name not in", values, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameBetween(String value1, String value2) {
            addCriterion("service_name between", value1, value2, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameNotBetween(String value1, String value2) {
            addCriterion("service_name not between", value1, value2, "serviceName");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameIsNull() {
            addCriterion("front_project_name is null");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameIsNotNull() {
            addCriterion("front_project_name is not null");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameEqualTo(String value) {
            addCriterion("front_project_name =", value, "frontProjectName");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameNotEqualTo(String value) {
            addCriterion("front_project_name <>", value, "frontProjectName");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameGreaterThan(String value) {
            addCriterion("front_project_name >", value, "frontProjectName");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameGreaterThanOrEqualTo(String value) {
            addCriterion("front_project_name >=", value, "frontProjectName");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameLessThan(String value) {
            addCriterion("front_project_name <", value, "frontProjectName");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameLessThanOrEqualTo(String value) {
            addCriterion("front_project_name <=", value, "frontProjectName");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameLike(String value) {
            addCriterion("front_project_name like", value, "frontProjectName");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameNotLike(String value) {
            addCriterion("front_project_name not like", value, "frontProjectName");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameIn(List<String> values) {
            addCriterion("front_project_name in", values, "frontProjectName");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameNotIn(List<String> values) {
            addCriterion("front_project_name not in", values, "frontProjectName");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameBetween(String value1, String value2) {
            addCriterion("front_project_name between", value1, value2, "frontProjectName");
            return (Criteria) this;
        }

        public Criteria andFrontProjectNameNotBetween(String value1, String value2) {
            addCriterion("front_project_name not between", value1, value2, "frontProjectName");
            return (Criteria) this;
        }

        public Criteria andMethodIsNull() {
            addCriterion("method is null");
            return (Criteria) this;
        }

        public Criteria andMethodIsNotNull() {
            addCriterion("method is not null");
            return (Criteria) this;
        }

        public Criteria andMethodEqualTo(String value) {
            addCriterion("method =", value, "method");
            return (Criteria) this;
        }

        public Criteria andMethodNotEqualTo(String value) {
            addCriterion("method <>", value, "method");
            return (Criteria) this;
        }

        public Criteria andMethodGreaterThan(String value) {
            addCriterion("method >", value, "method");
            return (Criteria) this;
        }

        public Criteria andMethodGreaterThanOrEqualTo(String value) {
            addCriterion("method >=", value, "method");
            return (Criteria) this;
        }

        public Criteria andMethodLessThan(String value) {
            addCriterion("method <", value, "method");
            return (Criteria) this;
        }

        public Criteria andMethodLessThanOrEqualTo(String value) {
            addCriterion("method <=", value, "method");
            return (Criteria) this;
        }

        public Criteria andMethodLike(String value) {
            addCriterion("method like", value, "method");
            return (Criteria) this;
        }

        public Criteria andMethodNotLike(String value) {
            addCriterion("method not like", value, "method");
            return (Criteria) this;
        }

        public Criteria andMethodIn(List<String> values) {
            addCriterion("method in", values, "method");
            return (Criteria) this;
        }

        public Criteria andMethodNotIn(List<String> values) {
            addCriterion("method not in", values, "method");
            return (Criteria) this;
        }

        public Criteria andMethodBetween(String value1, String value2) {
            addCriterion("method between", value1, value2, "method");
            return (Criteria) this;
        }

        public Criteria andMethodNotBetween(String value1, String value2) {
            addCriterion("method not between", value1, value2, "method");
            return (Criteria) this;
        }

        public Criteria andUserSystemIsNull() {
            addCriterion("user_system is null");
            return (Criteria) this;
        }

        public Criteria andUserSystemIsNotNull() {
            addCriterion("user_system is not null");
            return (Criteria) this;
        }

        public Criteria andUserSystemEqualTo(String value) {
            addCriterion("user_system =", value, "userSystem");
            return (Criteria) this;
        }

        public Criteria andUserSystemNotEqualTo(String value) {
            addCriterion("user_system <>", value, "userSystem");
            return (Criteria) this;
        }

        public Criteria andUserSystemGreaterThan(String value) {
            addCriterion("user_system >", value, "userSystem");
            return (Criteria) this;
        }

        public Criteria andUserSystemGreaterThanOrEqualTo(String value) {
            addCriterion("user_system >=", value, "userSystem");
            return (Criteria) this;
        }

        public Criteria andUserSystemLessThan(String value) {
            addCriterion("user_system <", value, "userSystem");
            return (Criteria) this;
        }

        public Criteria andUserSystemLessThanOrEqualTo(String value) {
            addCriterion("user_system <=", value, "userSystem");
            return (Criteria) this;
        }

        public Criteria andUserSystemLike(String value) {
            addCriterion("user_system like", value, "userSystem");
            return (Criteria) this;
        }

        public Criteria andUserSystemNotLike(String value) {
            addCriterion("user_system not like", value, "userSystem");
            return (Criteria) this;
        }

        public Criteria andUserSystemIn(List<String> values) {
            addCriterion("user_system in", values, "userSystem");
            return (Criteria) this;
        }

        public Criteria andUserSystemNotIn(List<String> values) {
            addCriterion("user_system not in", values, "userSystem");
            return (Criteria) this;
        }

        public Criteria andUserSystemBetween(String value1, String value2) {
            addCriterion("user_system between", value1, value2, "userSystem");
            return (Criteria) this;
        }

        public Criteria andUserSystemNotBetween(String value1, String value2) {
            addCriterion("user_system not between", value1, value2, "userSystem");
            return (Criteria) this;
        }

        public Criteria andUserDeviceIsNull() {
            addCriterion("user_device is null");
            return (Criteria) this;
        }

        public Criteria andUserDeviceIsNotNull() {
            addCriterion("user_device is not null");
            return (Criteria) this;
        }

        public Criteria andUserDeviceEqualTo(String value) {
            addCriterion("user_device =", value, "userDevice");
            return (Criteria) this;
        }

        public Criteria andUserDeviceNotEqualTo(String value) {
            addCriterion("user_device <>", value, "userDevice");
            return (Criteria) this;
        }

        public Criteria andUserDeviceGreaterThan(String value) {
            addCriterion("user_device >", value, "userDevice");
            return (Criteria) this;
        }

        public Criteria andUserDeviceGreaterThanOrEqualTo(String value) {
            addCriterion("user_device >=", value, "userDevice");
            return (Criteria) this;
        }

        public Criteria andUserDeviceLessThan(String value) {
            addCriterion("user_device <", value, "userDevice");
            return (Criteria) this;
        }

        public Criteria andUserDeviceLessThanOrEqualTo(String value) {
            addCriterion("user_device <=", value, "userDevice");
            return (Criteria) this;
        }

        public Criteria andUserDeviceLike(String value) {
            addCriterion("user_device like", value, "userDevice");
            return (Criteria) this;
        }

        public Criteria andUserDeviceNotLike(String value) {
            addCriterion("user_device not like", value, "userDevice");
            return (Criteria) this;
        }

        public Criteria andUserDeviceIn(List<String> values) {
            addCriterion("user_device in", values, "userDevice");
            return (Criteria) this;
        }

        public Criteria andUserDeviceNotIn(List<String> values) {
            addCriterion("user_device not in", values, "userDevice");
            return (Criteria) this;
        }

        public Criteria andUserDeviceBetween(String value1, String value2) {
            addCriterion("user_device between", value1, value2, "userDevice");
            return (Criteria) this;
        }

        public Criteria andUserDeviceNotBetween(String value1, String value2) {
            addCriterion("user_device not between", value1, value2, "userDevice");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(String value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(String value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(String value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(String value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(String value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLike(String value) {
            addCriterion("user_id like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotLike(String value) {
            addCriterion("user_id not like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<String> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<String> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(String value1, String value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(String value1, String value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andSourceIpIsNull() {
            addCriterion("source_ip is null");
            return (Criteria) this;
        }

        public Criteria andSourceIpIsNotNull() {
            addCriterion("source_ip is not null");
            return (Criteria) this;
        }

        public Criteria andSourceIpEqualTo(String value) {
            addCriterion("source_ip =", value, "sourceIp");
            return (Criteria) this;
        }

        public Criteria andSourceIpNotEqualTo(String value) {
            addCriterion("source_ip <>", value, "sourceIp");
            return (Criteria) this;
        }

        public Criteria andSourceIpGreaterThan(String value) {
            addCriterion("source_ip >", value, "sourceIp");
            return (Criteria) this;
        }

        public Criteria andSourceIpGreaterThanOrEqualTo(String value) {
            addCriterion("source_ip >=", value, "sourceIp");
            return (Criteria) this;
        }

        public Criteria andSourceIpLessThan(String value) {
            addCriterion("source_ip <", value, "sourceIp");
            return (Criteria) this;
        }

        public Criteria andSourceIpLessThanOrEqualTo(String value) {
            addCriterion("source_ip <=", value, "sourceIp");
            return (Criteria) this;
        }

        public Criteria andSourceIpLike(String value) {
            addCriterion("source_ip like", value, "sourceIp");
            return (Criteria) this;
        }

        public Criteria andSourceIpNotLike(String value) {
            addCriterion("source_ip not like", value, "sourceIp");
            return (Criteria) this;
        }

        public Criteria andSourceIpIn(List<String> values) {
            addCriterion("source_ip in", values, "sourceIp");
            return (Criteria) this;
        }

        public Criteria andSourceIpNotIn(List<String> values) {
            addCriterion("source_ip not in", values, "sourceIp");
            return (Criteria) this;
        }

        public Criteria andSourceIpBetween(String value1, String value2) {
            addCriterion("source_ip between", value1, value2, "sourceIp");
            return (Criteria) this;
        }

        public Criteria andSourceIpNotBetween(String value1, String value2) {
            addCriterion("source_ip not between", value1, value2, "sourceIp");
            return (Criteria) this;
        }

        public Criteria andServiceIpIsNull() {
            addCriterion("service_ip is null");
            return (Criteria) this;
        }

        public Criteria andServiceIpIsNotNull() {
            addCriterion("service_ip is not null");
            return (Criteria) this;
        }

        public Criteria andServiceIpEqualTo(String value) {
            addCriterion("service_ip =", value, "serviceIp");
            return (Criteria) this;
        }

        public Criteria andServiceIpNotEqualTo(String value) {
            addCriterion("service_ip <>", value, "serviceIp");
            return (Criteria) this;
        }

        public Criteria andServiceIpGreaterThan(String value) {
            addCriterion("service_ip >", value, "serviceIp");
            return (Criteria) this;
        }

        public Criteria andServiceIpGreaterThanOrEqualTo(String value) {
            addCriterion("service_ip >=", value, "serviceIp");
            return (Criteria) this;
        }

        public Criteria andServiceIpLessThan(String value) {
            addCriterion("service_ip <", value, "serviceIp");
            return (Criteria) this;
        }

        public Criteria andServiceIpLessThanOrEqualTo(String value) {
            addCriterion("service_ip <=", value, "serviceIp");
            return (Criteria) this;
        }

        public Criteria andServiceIpLike(String value) {
            addCriterion("service_ip like", value, "serviceIp");
            return (Criteria) this;
        }

        public Criteria andServiceIpNotLike(String value) {
            addCriterion("service_ip not like", value, "serviceIp");
            return (Criteria) this;
        }

        public Criteria andServiceIpIn(List<String> values) {
            addCriterion("service_ip in", values, "serviceIp");
            return (Criteria) this;
        }

        public Criteria andServiceIpNotIn(List<String> values) {
            addCriterion("service_ip not in", values, "serviceIp");
            return (Criteria) this;
        }

        public Criteria andServiceIpBetween(String value1, String value2) {
            addCriterion("service_ip between", value1, value2, "serviceIp");
            return (Criteria) this;
        }

        public Criteria andServiceIpNotBetween(String value1, String value2) {
            addCriterion("service_ip not between", value1, value2, "serviceIp");
            return (Criteria) this;
        }

        public Criteria andMsgIdIsNull() {
            addCriterion("msg_id is null");
            return (Criteria) this;
        }

        public Criteria andMsgIdIsNotNull() {
            addCriterion("msg_id is not null");
            return (Criteria) this;
        }

        public Criteria andMsgIdEqualTo(String value) {
            addCriterion("msg_id =", value, "msgId");
            return (Criteria) this;
        }

        public Criteria andMsgIdNotEqualTo(String value) {
            addCriterion("msg_id <>", value, "msgId");
            return (Criteria) this;
        }

        public Criteria andMsgIdGreaterThan(String value) {
            addCriterion("msg_id >", value, "msgId");
            return (Criteria) this;
        }

        public Criteria andMsgIdGreaterThanOrEqualTo(String value) {
            addCriterion("msg_id >=", value, "msgId");
            return (Criteria) this;
        }

        public Criteria andMsgIdLessThan(String value) {
            addCriterion("msg_id <", value, "msgId");
            return (Criteria) this;
        }

        public Criteria andMsgIdLessThanOrEqualTo(String value) {
            addCriterion("msg_id <=", value, "msgId");
            return (Criteria) this;
        }

        public Criteria andMsgIdLike(String value) {
            addCriterion("msg_id like", value, "msgId");
            return (Criteria) this;
        }

        public Criteria andMsgIdNotLike(String value) {
            addCriterion("msg_id not like", value, "msgId");
            return (Criteria) this;
        }

        public Criteria andMsgIdIn(List<String> values) {
            addCriterion("msg_id in", values, "msgId");
            return (Criteria) this;
        }

        public Criteria andMsgIdNotIn(List<String> values) {
            addCriterion("msg_id not in", values, "msgId");
            return (Criteria) this;
        }

        public Criteria andMsgIdBetween(String value1, String value2) {
            addCriterion("msg_id between", value1, value2, "msgId");
            return (Criteria) this;
        }

        public Criteria andMsgIdNotBetween(String value1, String value2) {
            addCriterion("msg_id not between", value1, value2, "msgId");
            return (Criteria) this;
        }

        public Criteria andVersionIsNull() {
            addCriterion("version is null");
            return (Criteria) this;
        }

        public Criteria andVersionIsNotNull() {
            addCriterion("version is not null");
            return (Criteria) this;
        }

        public Criteria andVersionEqualTo(String value) {
            addCriterion("version =", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotEqualTo(String value) {
            addCriterion("version <>", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionGreaterThan(String value) {
            addCriterion("version >", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionGreaterThanOrEqualTo(String value) {
            addCriterion("version >=", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLessThan(String value) {
            addCriterion("version <", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLessThanOrEqualTo(String value) {
            addCriterion("version <=", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionLike(String value) {
            addCriterion("version like", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotLike(String value) {
            addCriterion("version not like", value, "version");
            return (Criteria) this;
        }

        public Criteria andVersionIn(List<String> values) {
            addCriterion("version in", values, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotIn(List<String> values) {
            addCriterion("version not in", values, "version");
            return (Criteria) this;
        }

        public Criteria andVersionBetween(String value1, String value2) {
            addCriterion("version between", value1, value2, "version");
            return (Criteria) this;
        }

        public Criteria andVersionNotBetween(String value1, String value2) {
            addCriterion("version not between", value1, value2, "version");
            return (Criteria) this;
        }

        public Criteria andStatusCodeIsNull() {
            addCriterion("status_code is null");
            return (Criteria) this;
        }

        public Criteria andStatusCodeIsNotNull() {
            addCriterion("status_code is not null");
            return (Criteria) this;
        }

        public Criteria andStatusCodeEqualTo(Integer value) {
            addCriterion("status_code =", value, "statusCode");
            return (Criteria) this;
        }

        public Criteria andStatusCodeNotEqualTo(Integer value) {
            addCriterion("status_code <>", value, "statusCode");
            return (Criteria) this;
        }

        public Criteria andStatusCodeGreaterThan(Integer value) {
            addCriterion("status_code >", value, "statusCode");
            return (Criteria) this;
        }

        public Criteria andStatusCodeGreaterThanOrEqualTo(Integer value) {
            addCriterion("status_code >=", value, "statusCode");
            return (Criteria) this;
        }

        public Criteria andStatusCodeLessThan(Integer value) {
            addCriterion("status_code <", value, "statusCode");
            return (Criteria) this;
        }

        public Criteria andStatusCodeLessThanOrEqualTo(Integer value) {
            addCriterion("status_code <=", value, "statusCode");
            return (Criteria) this;
        }

        public Criteria andStatusCodeIn(List<Integer> values) {
            addCriterion("status_code in", values, "statusCode");
            return (Criteria) this;
        }

        public Criteria andStatusCodeNotIn(List<Integer> values) {
            addCriterion("status_code not in", values, "statusCode");
            return (Criteria) this;
        }

        public Criteria andStatusCodeBetween(Integer value1, Integer value2) {
            addCriterion("status_code between", value1, value2, "statusCode");
            return (Criteria) this;
        }

        public Criteria andStatusCodeNotBetween(Integer value1, Integer value2) {
            addCriterion("status_code not between", value1, value2, "statusCode");
            return (Criteria) this;
        }

        public Criteria andAnalysisCodeIsNull() {
            addCriterion("analysis_code is null");
            return (Criteria) this;
        }

        public Criteria andAnalysisCodeIsNotNull() {
            addCriterion("analysis_code is not null");
            return (Criteria) this;
        }

        public Criteria andAnalysisCodeEqualTo(Integer value) {
            addCriterion("analysis_code =", value, "analysisCode");
            return (Criteria) this;
        }

        public Criteria andAnalysisCodeNotEqualTo(Integer value) {
            addCriterion("analysis_code <>", value, "analysisCode");
            return (Criteria) this;
        }

        public Criteria andAnalysisCodeGreaterThan(Integer value) {
            addCriterion("analysis_code >", value, "analysisCode");
            return (Criteria) this;
        }

        public Criteria andAnalysisCodeGreaterThanOrEqualTo(Integer value) {
            addCriterion("analysis_code >=", value, "analysisCode");
            return (Criteria) this;
        }

        public Criteria andAnalysisCodeLessThan(Integer value) {
            addCriterion("analysis_code <", value, "analysisCode");
            return (Criteria) this;
        }

        public Criteria andAnalysisCodeLessThanOrEqualTo(Integer value) {
            addCriterion("analysis_code <=", value, "analysisCode");
            return (Criteria) this;
        }

        public Criteria andAnalysisCodeIn(List<Integer> values) {
            addCriterion("analysis_code in", values, "analysisCode");
            return (Criteria) this;
        }

        public Criteria andAnalysisCodeNotIn(List<Integer> values) {
            addCriterion("analysis_code not in", values, "analysisCode");
            return (Criteria) this;
        }

        public Criteria andAnalysisCodeBetween(Integer value1, Integer value2) {
            addCriterion("analysis_code between", value1, value2, "analysisCode");
            return (Criteria) this;
        }

        public Criteria andAnalysisCodeNotBetween(Integer value1, Integer value2) {
            addCriterion("analysis_code not between", value1, value2, "analysisCode");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgIsNull() {
            addCriterion("analysis_msg is null");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgIsNotNull() {
            addCriterion("analysis_msg is not null");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgEqualTo(String value) {
            addCriterion("analysis_msg =", value, "analysisMsg");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgNotEqualTo(String value) {
            addCriterion("analysis_msg <>", value, "analysisMsg");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgGreaterThan(String value) {
            addCriterion("analysis_msg >", value, "analysisMsg");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgGreaterThanOrEqualTo(String value) {
            addCriterion("analysis_msg >=", value, "analysisMsg");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgLessThan(String value) {
            addCriterion("analysis_msg <", value, "analysisMsg");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgLessThanOrEqualTo(String value) {
            addCriterion("analysis_msg <=", value, "analysisMsg");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgLike(String value) {
            addCriterion("analysis_msg like", value, "analysisMsg");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgNotLike(String value) {
            addCriterion("analysis_msg not like", value, "analysisMsg");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgIn(List<String> values) {
            addCriterion("analysis_msg in", values, "analysisMsg");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgNotIn(List<String> values) {
            addCriterion("analysis_msg not in", values, "analysisMsg");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgBetween(String value1, String value2) {
            addCriterion("analysis_msg between", value1, value2, "analysisMsg");
            return (Criteria) this;
        }

        public Criteria andAnalysisMsgNotBetween(String value1, String value2) {
            addCriterion("analysis_msg not between", value1, value2, "analysisMsg");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}